POJ3126 Prime Path(bfs)

来源:互联网 发布:mac鼠标右键怎么按 编辑:程序博客网 时间:2024/05/21 07:47

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670


给你两个四位数字,每次可以变换一个数字,变换得到的数必须是质数且不能重复,问你最少经过几次可以得到。


枚举每位然后判断是否是素数。


AC代码:


#include "iostream"#include "cstdio"#include "cstring"#include "algorithm"using namespace std;struct node{/* data */int prime, step;};int a, b;bool vis[15000];node q[15000];bool judgeprime(int a){if(a == 2 || a == 3) return true;else if(a <= 1 || a % 2 == 0) return false;else if(a > 3) {for(int i = 3; i * i <= a; ++i)if(a % i == 0) return false;return true;}}void bfs(){int head, tail;q[head = tail = 0].prime = a;q[tail++].step = 0;vis[a] = true;while(head < tail) {node x = q[head++];if(x.prime == b) {cout << x.step << endl;return;}int unit = x.prime % 10, deca = (x.prime / 10) % 10;for(int i = 1; i <= 9; i += 2) {int y = (x.prime / 10) * 10 + i;if(y != x.prime && !vis[y] && judgeprime(y)) {vis[y] = true;q[tail].prime = y;q[tail++].step = x.step + 1;}}for(int i = 0; i <= 9; ++i) {int y = (x.prime / 100) * 100 + i * 10 + unit;if(y != x.prime && !vis[y] && judgeprime(y)) {vis[y] = true;q[tail].prime = y;q[tail++].step = x.step + 1;}}for(int i = 0; i <= 9; ++i) {int y = (x.prime / 1000) * 1000 + i * 100 + deca * 10 + unit;if(y != x.prime && !vis[y] && judgeprime(y)) {vis[y] = true;q[tail].prime = y;q[tail++].step = x.step + 1;}}for(int i = 1; i <= 9; ++i) {int y = x.prime % 1000 + i * 1000;if(y != x.prime && !vis[y] && judgeprime(y)) {vis[y] = true;q[tail].prime = y;q[tail++].step = x.step + 1;}}}}int main(int argc, char const *argv[]){int t;cin >> t;while(t--) {cin >> a >> b;memset(vis, false, sizeof(vis));bfs();}return 0;}


1 0
原创粉丝点击